<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<title>Bayes HyperCube Browser: CESP</title>
  <META http-equiv="Content-Script-Type" content="text/javascript">
	<script type="text/javascript" language="javascript" src="./mSelecTable.js">	</script>
	<script type="text/javascript" language="javascript" src="./divPager.js">	</script>
	<script type="text/javascript" language="javascript" class="init">
  
/////////////////////////////////////////////////////////////////////////////
function addTableFromUrl(args)  
/////////////////////////////////////////////////////////////////////////////
{
  //console.log('addTableFromUrl('+args.pageName+')');
  var urlArgs = '';
  for(i=0; i<args.urlArgs.length; i++)
  {
    urlArgs += "&"+args.urlArgs[i].name+"="+
      encodeURIComponent(args.urlArgs[i].value);
  }
  var dp = new mSelecTable({
    active : args.isActive,
    container : 'Test01MainDiv',
    name : args.pageName,
    keyFieldIdx : args.keyFieldIdx,
    hiddenCols : args.hiddenCols,
    allowAllKeyWhenEmpty: args.allowAllKeyWhenEmpty,
    buttons : args.buttons,
    enabledButtons: args.buttons,
    url : "./dbTabJson.php?tabEngine="+encodeURIComponent('DataTable')+
          urlArgs,
    scrollY : 300, 
    dom : 'Bft',
    cssTableClassModifiers : '!nowrap'
  });
  divPagerMain.addPage(dp);
  return(dp)
};

/////////////////////////////////////////////////////////////////////////////
function addTableFromQuery(args)  
/////////////////////////////////////////////////////////////////////////////
{
  args.urlArgs = [
  { name:'dbtask', value:'query'},
  { name:'dbquery', value:args.query } ];
  return(addTableFromUrl(args));
};
    
/////////////////////////////////////////////////////////////////////////////
function classifyByDataset(args_)
/////////////////////////////////////////////////////////////////////////////
{
//console.log(args_);
  var json_ = $.ajax({
    url: "./dbTabJson.php?tabEngine="+encodeURIComponent('DataTable')+
    "&dbtask=query&dbquery="+encodeURIComponent(args_.query),
    contentType: "charset=utf-8",  
    dataType:'json',
    async: false}).responseText;
//console.log(json_);
  var table_ = JSON.parse(json_);
//console.log(table_);
  var dsList_ = {};
  var rows = table_.data.length;
  for(var i=0; i < rows; i++)
  {
    var dataset = table_.data[i][args_.datasetFieldIdx];
    var target = table_.data[i][args_.targetfieldIdx];
  //console.log('dataset:'+dataset+' target:'+target)
    if (typeof(dsList_[dataset])==='undefined') { dsList_[dataset] = []; }
    dsList_[dataset].push(target);
  }; 
  var result = {
    args:args_,
    json:json_,
    table:table_,
    dsList:dsList_,
    getTarget: function (dataset, sep) 
    {
      dsList[dataset].join(sep)
    }
  };
  return(result);
};
     
var ds_dim = classifyByDataset({
datasetFieldIdx:0, 
targetfieldIdx:1,
query: '                           \
SELECT co_dataset, co_dimension    \
FROM def_serie_key                 \
GROUP BY co_dataset, co_dimension  \
ORDER BY co_dataset, co_dimension  '
});   
  
var ds_key = classifyByDataset({
datasetFieldIdx:0, 
targetfieldIdx:1,
query:'                                           \
SELECT co_dataset,                                \
concat(co_dimension, \'.\', co_key) as co_dimkey  \
FROM def_serie_key                                \
GROUP BY co_dataset, co_dimension, co_key         \
ORDER BY co_dataset, co_dimension, co_key         '
});

var pagePreparer = 
{
  Datasets : function(pageName) 
  { 
    divPagerMain.removePage('Summary');
    divPagerMain.removePage('Table');
    divPagerMain.removePage('Chart');
  },
  Dimensions : function(pageName)
  {
    var selDataset = divPagerMain.getPage("Datasets").selKey;
  //console.log(selDataset); 
    var selDim = [];
    for(i=0; i<selDataset.length; i++)
    {
    //console.log(selDataset[i]); 
      var dim = ds_dim.dsList[selDataset[i]];
    //console.log(dim); 
      selDim = selDim.concat(dim);
    }
    var sel = selDim.join('|');
  //console.log(selDim); 
  //console.log(sel); 
    divPagerMain.getPage(pageName).filter(0,sel)
  },
  Keys : function(pageName)
  {
    var selDataset = divPagerMain.getPage("Datasets").selKey;
  //console.log(selDataset); 
    var selKey = [];
    for(i=0; i<selDataset.length; i++)
    {
    //console.log(selDataset[i]); 
      var dim = ds_key.dsList[selDataset[i]];
    //console.log(dim); 
      selKey = selKey.concat(dim);
    }
    var sel = selKey.join('|');
  //console.log(selKey); 
  //console.log(sel); 
    divPagerMain.removePage('Summary');
    divPagerMain.removePage('Table');
    divPagerMain.removePage('Chart');
    divPagerMain.getPage(pageName).filter(4,sel)
  },
  Summary : function(pageName)
  {
    var datasets = divPagerMain.getPage("Datasets").selKeySqlList(false);
  //console.log(datasets); 
    var keyValues = divPagerMain.getPage("Keys").selKeySqlList(false);
  //console.log(keyValues); 
    if((datasets.length==0)&&(keyValues.length==0))
    {
      alert('Sorry: You must select at least one or more datasets and one or more key values')
      clickPageButton("Datasets");
    }
    else if((datasets.length==0)&&(keyValues.length>0))
    {
      alert('Sorry: You must select at least one or more datasets')
      clickPageButton("Datasets");
    }
    else if((datasets.length>0)&&(keyValues.length==0))
    {
      alert('Sorry: You must select at least one or more key values')
      clickPageButton("Keys");
    }
    else
    {
      addTableFromUrl({
        pageName:"Summary",
        isActive:true,
        keyFieldIdx:0,
        allowAllKeyWhenEmpty:true,
        buttons:allButtons,
        enabledButtons:[],
        urlArgs:[
         { name:'dbtask', value:'seriesSummary' },
         { name:'datasets', value:datasets },
         { name:'keyValues', value:keyValues },
        ]});
      divPagerMain.removePage('Table');
      divPagerMain.removePage('Chart');
      divPagerMain.getPage(pageName).onReady($);
    }
  },
  Table : function(pgn)
  {
    if(!divPagerMain.existsPage("Summary"))
    {
      alert('Sorry: You must click Summary button before '+pgn);
    }
    else
    {
      var serCodes = divPagerMain.getPage("Summary").selKeySqlList(true);
      console.log('serCodes:'+serCodes);    
      addTableFromUrl({
        pageName:pgn,
        isActive:true,
        keyFieldIdx:0,
        buttons:allButtons,
        enabledButtons:[],
        urlArgs:[
         { name:'dbtask', value:'seriesDataFromCodes' },
         { name:'serCodes', value:serCodes }
        ]});
      divPagerMain.getPage(pgn).onReady($);
    } 
  },
  Chart : function(pgn)
  {
  }
};


/////////////////////////////////////////////////////////////////////////////
function clickPageButton(pgn)
/////////////////////////////////////////////////////////////////////////////
{
  pagePreparer[pgn](pgn);
  divPagerMain.show(pgn);  
};

/////////////////////////////////////////////////////////////////////////////
function createPageButton(divPagerMain,pageId)
/////////////////////////////////////////////////////////////////////////////
{
  var buttonInfo = { 
    text: pageId,
    action: function ( e, dt, node, config ) 
    {
    //console.log('createPageButton:action('+config.pageName+')');
      clickPageButton(config.pageName);
    } 
  };
  return(buttonInfo);
};


var divPagerMain = new divPager({
  container : 'Test01MainDiv'  
});  

var pageButtons = [
  createPageButton(divPagerMain,'Datasets'),
  createPageButton(divPagerMain,'Dimensions'),
  createPageButton(divPagerMain,'Keys'),
  createPageButton(divPagerMain,'Summary'),
  createPageButton(divPagerMain,'Table'),
  createPageButton(divPagerMain,'Chart')   
];

var datatableButtons = [
  'csv', 
  'excel', 
  'copy', 
  'print'
];

var allButtons = pageButtons.concat(datatableButtons);

function selPageButtons(buttonList)
{
  var sel = [];
  for(i=0; i<pageButtons.length; i++)
  {
    var found = buttonList[pageButtons[i].text];
    if(!(typeof(found)==='undefined'))
    {
      sel.push(pageButtons[i]);
    }
  }
};

addTableFromQuery({
  pageName:"Datasets",
  isActive:true,
  keyFieldIdx:0,
  buttons:allButtons,
  enabledButtons:['Datasets'],
  query:"SELECT "+
  "co_dataset as Name,"+
  "co_source as Source,"+
  "co_magnitude ||\' [\'||co_units_tol||\']\' as Magnitude,"+
  "co_base_dating as Freq, "+
  "replace(te_dimensions,',',', ') as Dimensions,"+
  "te_description as Description "+
  "FROM def_dataset "+
  "ORDER BY id_dataset"});

addTableFromQuery({
  pageName:"Dimensions",
  isActive:false,
  keyFieldIdx:0,
  buttons:allButtons,
  enabledButtons:['Datasets','Dimensions'],
  query:"SELECT "+
  "co_dimension as Name,"+
  "te_desc as Description "+
  "FROM def_dimension "+
  "ORDER BY co_dimension"});        

addTableFromQuery({
  pageName:"Keys",
  isActive:false,
  keyFieldIdx:4,
  buttons:allButtons,
  enabledButtons:['Datasets','Dimensions','Keys'],
  query:"SELECT "+
  "co_dimension as Dimension,"+
  "co_name as Name, "+
  "co_key as Code, "+
  "te_description as Description,  "+
  "concat(co_dimension,'.',co_key) as co_dimkey \n"+  
  "FROM def_key "+
  "ORDER BY co_dimension,co_key",
  hiddenCols:['co_dimkey']});

jQuery( document ).ready( function( $ ) 
{ 
  divPagerMain.onReady($);
//divPagerMain.show('Datasets');
});

/* */    

	</script>
</head>
<body class="dt-example">
  <div id="Test01MainDiv">
  </div>
</body>
</html>